%%
%% $Id: algo.tex,v 1.2 2002-02-18 21:49:24 mbaur Exp $
%%
%% This file supplies an algorithm figure for the JNuke deserializer
%% documentation. Once this file is \include'd, it is available as 
%% \DeserializationAlgorithm.
%%

\newcommand{\DeserializationAlgo}{
    \begin{figure}[ht!]
    \begin{center}

    \footnotesize
    \framebox{
    \begin{pseudocode}{Deserializtaion Algorithm}{stream}

\PROCEDURE{def}{cur}
\COMMENT{handle definitions} \\
	\IF marked(cur.saddr) \THEN \BEGIN
		abort("\textsf{saddr twice defined}"); \\
	\END
	\\\
	create(cur); \\
	mark(cur);  \\
	
	\FOREACH i \in cur.args \DO \BEGIN
		\IF  !marked($i$) \THEN \BEGIN
		process(i.saddr); \\
		cur.restoreElement(i);
		\END 
	\END
\ENDPROCEDURE

\PROCEDURE{ref}{cur}
	\IF (!marked(cur)) \THEN \BEGIN
		abort("\textsf{external ref without def}"); \\
	\END
	\\
	this.final \GETS cur; \\
	\IF (saddr(final) == stopsaddr) \THEN \BEGIN
		\EXIT
	\END
\ENDPROCEDURE

\PROCEDURE{process}{[stopsaddr]}
\WHILE (!this.it.done) \DO \BEGIN
	get(cur); \\
	\IF (\textrm{cur is definition}) \THEN \CALL{def}{cur}; \\
	\IF (\textrm{cur is reference})  \THEN \CALL{ref}{cur}; \\
	\IF (\textrm{cur is neither})    \THEN abort("\textsf{invalid command}"); \\	
\END
\ENDPROCEDURE


\MAIN
\BEGIN
	this.final \GETS NULL; \\
	vec \GETS Vector(stream); \\
	this.it \GETS VectorIterator; \\
	\CALL{process}{this}; \\
	\RETURN this.final; \\
\END
\ENDMAIN
    \end{pseudocode}
    } %% framebox
    \normalsize
    \end{center}
    \label{algo}
    \caption{Deserialization Algorithm}
    \end{figure}
}

%% EOF
